#!/bin/sh

PING_URL=srv://auth.netgate.com/ping
PING_AUTH=/usr/local/sbin/ping-auth
OPENSSL=/usr/bin/openssl
THOTH_PATH=/etc/thoth
CHMOD=/bin/chmod
CHOWN=/usr/sbin/chown

# Certificates
DEVICE_CERT=${THOTH_PATH}/device.pem
DEVICE_KEY=${THOTH_PATH}/key.pem
CA_CERT=${THOTH_PATH}/ca.pem

if [ ! -f ${DEVICE_CERT} ]; then
	${OPENSSL} engine ateccx08 -t -post GET_DEVICE_CERT:${THOTH_PATH}/device.der > /dev/null
	${OPENSSL} x509 -inform der -in ${THOTH_PATH}/device.der -outform pem -out ${DEVICE_CERT} > /dev/null
fi

if [ ! -f ${DEVICE_KEY} ]; then
	${OPENSSL} engine ateccx08 -t -post GET_DEVICE_KEY:${DEVICE_KEY} > /dev/null
	${CHOWN} root:wheel ${DEVICE_KEY}
	${CHMOD} 0400 ${DEVICE_KEY}
fi

if [ ! -f ${DEVICE_KEY}  -o ! -f ${DEVICE_CERT} -o ! -f ${CA_CERT} ]; then
	echo missing files, exiting.
	exit 1
fi

${PING_AUTH} --ca-cert ${CA_CERT} --cert ${DEVICE_CERT} --privkey ${DEVICE_KEY} ${PING_URL}
